#ifndef __CEPAPI_BUFFER_H__
#define __CEPAPI_BUFFER_H__

#include "x/api.h"

typedef struct s_line_buffer {
	struct s_line_buffer *previous, *next;
	int line_no;
	int content_len;
	int buffer_len;
	t_char buffer[1];
}t_line_buffer;

typedef struct s_buffer {
	t_line_buffer *lines;
	int line_count;
	int default_line_length;
}t_buffer;

KAILIN_API int buffer_create(t_buffer *buf, int max_line_length);
KAILIN_API int buffer_destroy(t_buffer *buf);
KAILIN_API int buffer_insert_line(t_buffer *buf, int line_no, t_line_buffer **o_line);
KAILIN_API int buffer_delete_line(t_buffer *buf, int line_no, int count);
KAILIN_API int buffer_get_line(t_buffer *buf, int line_no, t_line_buffer **o_line);
KAILIN_API int buffer_get_max_line_no(t_buffer *buf, int *o_line_no);
KAILIN_API int buffer_line_set_char(t_line_buffer *line, int index, int len, int overwrite, const t_char *text, int *o_len);
KAILIN_API int buffer_line_get_char(t_line_buffer *line, int index, t_char *o_achar);
KAILIN_API int buffer_line_get_info(t_line_buffer *line, t_char **o_buffer, int *o_length, int *o_no);
KAILIN_API int buffer_line_delete_char(t_line_buffer *line, int index, int len);
KAILIN_API int buffer_line_is_last(t_line_buffer *line, int index);
KAILIN_API int buffer_line_load(t_line_buffer *line, int index, int buff_len, const char *buff, int *o_buff_len, int *o_count);
KAILIN_API int buffer_line_save(t_line_buffer *line, int index, int buff_len, char *buff, int *o_buff_len, int *o_count);

#endif
