#ifndef __CEPAPI_COMMAND_H__
#define __CEPAPI_COMMAND_H__

#include "x/api.h"

/* user need not to know who will process the command
 * indeed, rely on the dispatching system
*/

/*****************/
/* command list */
/***************/

/* window_do_command(t_window *win, COMMAND_CLEAR_DESKTOP, NULL, 0); */
//#define COMMAND_CLEAR_DESKTOP          11
/* window_do_command(t_window *win, COMMAND_SWITCH_DESKTOP, int *win_id, sizeof(int)); */
//#define COMMAND_SWITCH_DESKTOP         15

/* window_do_command(t_window *win, COMMAND_NEW_DESKTOP, int *type_id, sizeof(int)); */
/* window_do_command(t_window *win, COMMAND_NEW_DESKTOP, t_parameter_new_desktop *param, sizeof(t_parameter_new_desktop)); */
#define COMMAND_NEW_DESKTOP            12

/* window_do_command(t_window *win, COMMAND_CLOSE_DESKTOP, int *pop_count, sizeof(int)); */
#define COMMAND_CLOSE_DESKTOP          13

/* window_do_response(t_window *win, RESPONSE_DESKTOP_OK, void *req_param, int req_param_len); */
#define RESPONSE_DESKTOP_OK             100

/* window_do_response(t_window *win, RESPONSE_DESKTOP_CANCLE, void *req_param, int req_param_len); */
#define RESPONSE_DESKTOP_CANCLE         101

/* window_do_command(t_window *win, COMMAND_CHANGE_HELP_MODE, NULL, 0); */
#define COMMAND_CHANGE_HELP_MODE       600

/* window_do_command(t_window *win, COMMAND_GET_STYLE, t_parameter_style *o_style, sizeof(t_parameter_style)); */
#define COMMAND_GET_STYLE              800

/* window_do_command(t_window *win, COMMAND_CLOSE, NULL, 0); */
#define COMMAND_CLOSE                    1

/* window_do_command(t_window *win, COMMAND_RENAME, t_parameter_rename *rename, sizoef(t_parameter_rename)); */
#define COMMAND_RENAME                  20

/* window_do_command(t_window *win, COMMAND_SELECT_DESKTOP, int *id, sizeof(int)); */
#define COMMAND_SELECT_DESKTOP          1000

/***********************/
/* command parameters */
/*********************/

/* tag window type id */

#define WINDOW_ID_DESKTOP                      1
#define WINDOW_ID_LOGIN                       3
#define WINDOW_ID_MESSAGE                  4



#define WINDOW_ID_NEVI                     100

#define WINDOW_ID_INSERT                    101
#define WINDOW_ID_CONFIGURE                 102
#define WINDOW_ID_HELP                     104
#define WINDOW_ID_ABOUT                    105
#define WINDOW_ID_TETRIS                   106


#define WINDOW_COMMAND                    10000

/* structure define */

typedef struct s_parameter_new_desktop {
	int id_type; /* tag window type id */
	void *ext_data; /* window parameter */
	int ext_data_len; /* window parameter length */
}t_parameter_new_desktop;

typedef struct s_parameter_style {
	COLORREF bk_color;
	COLORREF dsk_color;
	COLORREF dsk_color_dark;
	COLORREF pen_color;
}t_parameter_style;

typedef struct s_parameter_rename {
	int id;
	const char *fmt;
	va_list vargs;
}t_parameter_rename;

/**********************/
/* command functions */
/********************/

KAILIN_API int command_not_imply(t_window *win);
KAILIN_API int command_close(t_window *win);
KAILIN_API int command_get_style(t_window *win, t_parameter_style *style);
KAILIN_API int command_change_help_mode(t_window *win);
KAILIN_API int command_close_desktop(t_window *win, int count);
KAILIN_API int command_new_desktop(t_window *win, int type);
KAILIN_API int command_new_desktop_with_param(t_window *win, int type, void *param, int param_len);
KAILIN_API int command_rename(t_window *win, const char *fmt, ...);
KAILIN_API int command_select_desktop(t_window *win, int id);

#endif
