#ifndef __CEPAPI_EBLIST_H__
#define __CEPAPI_EBLIST_H__

#include "x/api.h"

typedef struct s_eblist_node {
	struct s_eblist_node *previous, *next;
	t_buffer buffer;
	t_editbox editbox;
	t_text title;
	int id;
}t_eblist_node;

typedef struct s_eblist {
	int x, y;
	t_eblist_node *list;
	t_eblist_node *active;
}t_eblist;

KAILIN_API int eblist_create(t_window *win, t_eblist *el);
KAILIN_API int eblist_destroy(t_window *win, t_eblist *el);
KAILIN_API int eblist_append(t_window *win, t_eblist *el, char *text, int id, int length, char *data, int readonly);
KAILIN_API int eblist_get_text_width(t_window *win, t_eblist *el);
KAILIN_API int eblist_get_size(t_window *win, t_eblist *el, int *o_width, int *o_height);
KAILIN_API int eblist_set_pos(t_window *win, t_eblist *el, int ox, int oy);
KAILIN_API int eblist_on_update(t_window *win, t_eblist *el);
KAILIN_API int eblist_on_click(t_window *win, t_eblist *el, int x, int y);
KAILIN_API int eblist_on_active(t_window *win, t_eblist *el);
KAILIN_API int eblist_on_disactive(t_window *win, t_eblist *el);
KAILIN_API int eblist_on_press(t_window *win, t_eblist *el, int code);
KAILIN_API int eblist_on_input(t_window *win, t_eblist *el, t_char code);

#endif
