#ifndef __CEPAPI_EDITBOX_H__
#define __CEPAPI_EDITBOX_H__

#include "x/api.h"

typedef struct s_editbox {
	int x, y; /* in father coordinate */
	t_size size; /* box size */
	unsigned long flags;
#define EDITBOX_STYLE_PASSWORD     0x80000000UL
#define EDITBOX_STYLE_MULTILINE    0x40000000UL
#define EDITBOX_STYLE_READONLY     0x20000000UL
#define EDITBOX_STYLE_MASK         (EDITBOX_STYLE_PASSWORD|EDITBOX_STYLE_MULTILINE|EDITBOX_STYLE_READONLY)
	int orig_x, orig_y; /* in this coordinate */
	int cursor_x, cursor_y;
	int cursor_line, cursor_row; /* line and row */
	int active, overwrite;
	int border;
	int tab_space_count;
	t_buffer *buffer;
}t_editbox;

KAILIN_API int editbox_create(t_window *win, t_editbox *eb, t_size *size, t_buffer *buffer, unsigned long flags);
KAILIN_API int editbox_set_pos(t_window *win, t_editbox *eb, int x, int y);
KAILIN_API int editbox_get_size(t_window *win, t_editbox *eb, t_size *o_size);
KAILIN_API int editbox_on_input_char(t_window *win, t_editbox *eb, t_char achar);
KAILIN_API int editbox_on_press_key(t_window *win, t_editbox *eb, int keycode);
KAILIN_API int editbox_on_update(t_window *win, t_editbox *eb);
KAILIN_API int editbox_on_click(t_window *win, t_editbox *eb, int x, int y);
KAILIN_API int editbox_set_active(t_window *win, t_editbox *eb, int active);
KAILIN_API int editbox_on_active(t_window *win, t_editbox *eb);
KAILIN_API int editbox_on_disactive(t_window *win, t_editbox *eb);

#endif
