#ifndef __CEPAPI_TAGLIST_H__
#define __CEPAPI_TAGLIST_H__

#include "x/api.h"

typedef struct s_taglist_node {
	struct s_taglist_node *previous, *next;
	t_tag tag;
	int id;
}t_taglist_node;

typedef struct s_taglist {
	int x;
	int y;
	int width;
	int height;
	t_taglist_node *tags;
}t_taglist;

KAILIN_API int taglist_create_tag(t_window *win, t_taglist *lst, int id, const char *name);
KAILIN_API int taglist_delete_tag(t_window *win, t_taglist *lst, int id);
KAILIN_API int taglist_is_topest(t_window *win, t_taglist *lst, int id);
KAILIN_API int taglist_create(t_window *win, t_taglist *lst);
KAILIN_API int taglist_destroy(t_window *win, t_taglist *lst);
KAILIN_API int taglist_get_size(t_window *win, t_taglist *lst, int *o_width, int *o_height);
KAILIN_API int taglist_set_shape(t_window *win, t_taglist *lst, int width, int height);
KAILIN_API int taglist_on_click(t_window *win, t_taglist *lst, int x, int y);
KAILIN_API int taglist_on_scroll(t_window *win, t_taglist *lst, int dx, int dy);
KAILIN_API int taglist_on_update(t_window *win, t_taglist *lst);
KAILIN_API int taglist_on_move_over(t_window *win, t_taglist *lst, int x, int y);
KAILIN_API int taglist_set_name(t_window *win, t_taglist *lst, int id, const char *name, va_list vargs);
KAILIN_API int taglist_active(t_window *win, t_taglist *lst, int id);

#endif
