#ifndef __DIRECT_H__
#	define __DIRECT_H__

#	include "x/api.h"
#	include "x/type.h"
#	include "x/win32/win32.h"

#	define DIRENT_FLAGS_DIRECTORY     0x00000001

typedef struct s_dirent {
	uint8 name[MAX_PATH];
	uint32 flags;
}t_dirent;

typedef struct s_dir {
	const char *path, *filter;
	HANDLE hFind;
}t_dir;

KAILIN_API
 int direct_open(t_dir *dir, const char *path, const char *filter);
KAILIN_API
 int direct_close(t_dir *dir);
KAILIN_API
 int direct_read_dirent(t_dir *dir, t_dirent *dirent);
KAILIN_API
 int direct_get_path(t_dir *dir, t_dirent *dirent, uint8 *buff, uint32 len);
KAILIN_API
 int direct_get_path_length(t_dir *dir, t_dirent *dirent, uint32 *o_len);

//typedef struct s_direct_ops {
//	int (*direct_open)(t_dir *dir, const char *path, const char *filter);
//	int (*direct_close)(t_dir *dir);
//	int (*direct_read_dirent)(t_dir *dir, t_dirent *dirent);
//	int (*direct_get_path)(t_dir *dir, t_dirent *dirent, uint8 *buff, uint32 len);
//	int (*direct_get_path_length)(t_dir *dir, t_dirent *dirent, uint32 *o_len);
//}t_direct_ops;

//int direct_get_ops(t_direct_ops *o_ops);

#endif
