#ifndef __DEFINE_H__
#define __DEFINE_H__

#if 1

/*
 * integer
*/

typedef signed int   TInt; /* unfixed-length integer */
typedef signed char  TInt8;  /* signed integer */
typedef signed short TInt16;
typedef signed long  TInt32;

typedef unsigned int   TUInt; /* unfixed-length integer */
typedef unsigned char  TUInt8;  /* unsigned integer */
typedef unsigned short TUInt16;
typedef unsigned long  TUInt32;

/*
 * character
*/

typedef signed char    TChar;     /* ASCII, Multi-Bytes */
typedef unsigned long  TUnicode;  /* Unicode */

/*
 * Unicode Transfer Formation
*/

typedef unsigned char  TUTF8;
typedef unsigned short TUTF16;
typedef unsigned long  TUTF32;

/*
 * General character
*/

#ifdef UNICODE
/* Unicode currently is descripted by UTF-16 */
typedef TUTF16   TGChar;
#else
/* ASCII, Multi-Bytes */
typedef TChar    TGChar;
#endif

/*
 * Boolean
*/

typedef int TBoolean;

#define FALSE 0
#define TRUE  1

/*
 * Size
*/

typedef unsigned int TSize;

/*
 * Null Pointer
*/

#ifndef NULL

#ifdef __cplusplus
#define NULL 0
#else
#define NULL ((void*)0)
#endif

#endif

#endif

/*
 * get array length
 * a - array
*/

#define LENGTH(a) (sizeof(a)/sizeof((a)[0]))
/*#define ALEN(a) (sizeof(a)/sizeof((a)[0])*/

/*
 * get offset of field member
 * s - structure type name
 * f - field member name of structure type
*/

#define OFFSET(s,f) ((unsigned int)(&((s*)0)->f))

/*
 * reference unreferenced varialbe
 * used to avoid warning message
*/
#define REFER(p) ((void)(p))

#if 0

/*
 * clear memory block
 * a - memory block
 *
 * must include string.h at first
*/
#define ZERO(a) (memset(&(a), 0, sizeof(a)))

#endif

#endif
