#include "x/api.h"

struct _RPC_ASYNC_STATE;
#include <winsock2.h>
#include <ws2tcpip.h>

typedef union u_sockaddr {
	struct sockaddr sa;
	struct sockaddr_in sa_in;
	struct sockaddr_in6 sa_in6;
}t_sockaddr;

typedef struct s_socket {
	SOCKET sockfd;
}t_socket;

KAILIN_API
 int f_socket_init(void);
KAILIN_API
 int f_socket_exit(void);
KAILIN_API
 int f_socket_open(t_socket *p_socket, int family, int type, int proto);
KAILIN_API
 int f_socket_close(t_socket *p_socket);
KAILIN_API
 int f_socket_bind(t_socket *p_socket, t_sockaddr *p_sockaddr);
KAILIN_API
 int f_socket_listen(t_socket *p_socket, int backlog);
KAILIN_API
 int f_socket_connect(t_socket *p_socket, t_sockaddr *p_sockaddr);
KAILIN_API
 int f_socket_accept(t_socket *p_socket, t_socket *p_out_socket, t_sockaddr *p_out_sockaddr);
KAILIN_API
 int f_socket_read(t_socket *p_socket, void *p_buff, int buff_len, int *p_out_buff_len);
KAILIN_API
 int f_socket_recv(t_socket *p_socket, void *p_buff, int buff_len, int flags, int *p_out_buff_len);
KAILIN_API
 int f_socket_recvfrom(t_socket *p_socket, void *p_buff, int buff_len, int flags, int *p_out_buff_len, t_sockaddr *p_out_sockaddr);
KAILIN_API
 int f_socket_write(t_socket *p_socket, const void *p_buff, int buff_len, int *p_out_buff_len);
KAILIN_API
 int f_socket_send(t_socket *p_socket, const void *p_buff, int buff_len, int flags, int *p_out_buff_len);
KAILIN_API
 int f_socket_sendto(t_socket *p_socket, const void *p_buff, int buff_len, int flags, int *p_out_buff_len, const t_sockaddr *p_sockaddr);
KAILIN_API
 int f_socket_reading(t_socket *p_socket, long ms, void *p_buff, int bufflen, t_sockaddr *p_from, int *p_outlen);
KAILIN_API
 int f_socket_select(int maxfd1, fd_set *p_recv_set, fd_set *p_write_set, fd_set *p_except_set, struct timeval *p_tv, int *p_out_count);

typedef t_sockaddr TSocketAddress;
