/* define base types */

#ifndef __TYPE_H__
#define __TYPE_H__

/* unsigned integer */

typedef unsigned int   uint;
typedef unsigned char  uint8;
typedef unsigned short uint16;
typedef unsigned long  uint32;

/* signed integer */

/* invalid definition, compiler has already defined int type
typedef signed int   int;
*/

typedef signed char  int8;
typedef signed short int16;
typedef signed long  int32;

/* boolean */

/* use macro definition to avoid predefined error */

#define bool  int
#define false 0
#define true  1

/* IEEE float */

typedef float       float32;
typedef double      float64;
typedef long double float80;

/* character */

#ifdef UNICODE

typedef uint16      tchar;

#else

typedef uint8       tchar;

#endif

#endif
