#ifndef __CEPAPI_WIN32_H__
#	define __CEPAPI_WIN32_H__

#	include "x/api.h"

#	define WINVER 0x0500
#	include <windows.h>
#	include <mmsystem.h>

#	include <ctype.h>
#	include <stdarg.h>
#	include <stdio.h>
#	include <stdlib.h>
#	include <string.h>
#	include <time.h>

KAILIN_API
 ATOM    Win32RegisterClassEx(WNDCLASSEX *wc);
KAILIN_API
 HWND    Win32CreateWindow(LPCTSTR lpClassName,
						   LPCTSTR lpWindowName, DWORD dwStyle,
						   int x, int y, int nWidth, int nHeight,
						   HWND hWndParent, HMENU hMenu, HINSTANCE hInstance,
						   LPVOID lpParam);
KAILIN_API
 BOOL    Win32ShowWindow(HWND hWnd, int nShowCmd);
KAILIN_API
 BOOL    Win32UpdateWindow(HWND hWnd);
KAILIN_API
 BOOL    Win32DestroyWindow(HWND hWnd);
KAILIN_API
 int     Win32GetMessage(MSG *msg, HWND hWnd, UINT min, UINT max);
KAILIN_API
 BOOL    Win32TranslateMessage(LPMSG msg);
KAILIN_API
 LRESULT Win32DispatchMessage(LPMSG msg);
KAILIN_API
 int     Win32PostQuitMessage(int exitcode);
KAILIN_API
 LRESULT Win32DefWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
KAILIN_API
 int     Win32SetCapture(HWND hWnd);
KAILIN_API
 int     Win32ReleaseCapture(void);
KAILIN_API
 int     Win32GetClientRect(HWND hWnd, LPRECT o_rect);
KAILIN_API
 HICON   Win32LoadIconRes(HINSTANCE hInst, int nID);
KAILIN_API
 BOOL    Win32PeekMessage(LPMSG lpMsg, HWND hWnd, UINT uMin, UINT uMax, UINT uRemoval);
KAILIN_API
 BOOL    Win32PostMessage(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
KAILIN_API
 void    Win32Sleep(DWORD dwMilliSeconds);
KAILIN_API
 HGDIOBJ Win32GetStockObject(INT nIndex);
KAILIN_API
 HCURSOR Win32LoadCursor(HINSTANCE hInstance, LPCTSTR lpCursorName);
KAILIN_API
 HICON   Win32LoadIcon(HINSTANCE hInstance, LPCTSTR lpCursorName);

KAILIN_API HINSTANCE Win32GetInstanceHandle(HWND hWnd);
KAILIN_API HINSTANCE Win32GetModuleHandle(void);
KAILIN_API LPSTR Win32GetCommandLine(void);
KAILIN_API DWORD Win32GetModuleFileName(HINSTANCE hInstance, LPTSTR lpFilename, DWORD dwSize);
KAILIN_API LONG Win32GetWindowLong(HWND hWnd, int nIndex);

//typedef struct s_win32_ops {
//	ATOM    (*Win32RegisterClassEx)(WNDCLASSEX *wc);
//	HWND    (*Win32CreateWindow)(LPCTSTR lpClassName,
//						   LPCTSTR lpWindowName, DWORD dwStyle,
//						   int x, int y, int nWidth, int nHeight,
//						   HWND hWndParent, HMENU hMenu, HINSTANCE hInstance,
//						   LPVOID lpParam);
//	BOOL    (*Win32ShowWindow)(HWND hWnd, int nShowCmd);
//	BOOL    (*Win32UpdateWindow)(HWND hWnd);
//	BOOL    (*Win32DestroyWindow)(HWND hWnd);
//	int     (*Win32GetMessage)(MSG *msg, HWND hWnd, UINT min, UINT max);
//	BOOL    (*Win32TranslateMessage)(LPMSG msg);
//	LRESULT (*Win32DispatchMessage)(LPMSG msg);
//	int     (*Win32PostQuitMessage)(int exitcode);
//	LRESULT (*Win32DefWindowProc)(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
//	int     (*Win32SetCapture)(HWND hWnd);
//	int     (*Win32ReleaseCapture)(void);
//	int     (*Win32GetClientRect)(HWND hWnd, LPRECT o_rect);
//	HICON   (*Win32LoadIconRes)(HINSTANCE hInst, int nID);
//	BOOL    (*Win32PeekMessage)(LPMSG lpMsg, HWND hWnd, UINT uMin, UINT uMax, UINT uRemoval);
//	BOOL    (*Win32PostMessage)(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
//	void    (*Win32Sleep)(DWORD dwMilliSeconds);
//	HGDIOBJ (*Win32GetStockObject)(INT nIndex);
//	HCURSOR (*Win32LoadCursor)(HINSTANCE hInstance, LPCTSTR lpCursorName);
//	HICON   (*Win32LoadIcon)(HINSTANCE hInstance, LPCTSTR lpCursorName);
//}t_win32_ops;

//int win32_get_ops(t_win32_ops *o_ops);

#endif
