#ifndef __GETOPT_H__
#define __GETOPT_H__

#include "x/api.h"

#ifdef __cplusplus
extern "C" {
#endif

struct optarg {
	const char *full_name; /* must exist */
	const char *short_name; /* must exist */
	const char *descript_text; /* must exist */
	const char *arg_text; /* optional */
	/* output fields */
	const char *arg; /* if arg_text exist, then arg return the optional argument */
	int has;
};

struct optcmd {
	struct optarg *args;
	int arg_cnt;
	const char *descript_text; /* optional */
};

struct optctl {
	struct optcmd *cmds;
	int cmd_cnt;
	int default_cmd;
	/* output fields */
	int retval;
	char *file_name;
	int rootpath_cnt;
};

KAILIN_API
 int getopt(struct optctl *ctl, int argc, char *argv[]);

#ifdef __cplusplus
};
#endif

#endif /* end of ifndef __GETOPT_H__ */
