#ifndef __MSG_H__
#define __MSG_H__

#include "x/api.h"
#include "x/type.h"
#include "x/null.h"

struct _RPC_ASYNC_STATE;
#include <windows.h>
#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	char *text; /* dynamic string */
	struct s_msg_attribute {
		TCHAR FontName[LF_FACESIZE];
		LONG FontSize;
		COLORREF FontColor;
		uint32 TableSize;
		COLORREF Background;
	}attr;
	struct s_msg_hot_link {
		HRGN region;
		char *text;
	}*link; /* queue */
	struct s_msg_object { /* queue */
		HANDLE hThread;
		HANDLE lock;
		HDC hDC; /* created by procedure, and used and releaed by render */
		int obj_type;
#define SENDING_PROGRESS 1
#define RECVING_PROGRESS 2
		union s_msg_obj_parameter {
			struct s_msg_sending_param {
				char *source_file_name;
				char *target_file_name;
				time_t start_timestamp;
				uint32 total_byes;
				uint32 sent_bytes;
			}sending_param;
			struct s_msg_recving_param {
				char *source_file_name;
				char *target_file_name;
				time_t start_timestamp;
				uint32 total_byes;
				uint32 recv_bytes;
			}recving_param;
		}param;
	}*obj;
	struct s_msg_render_status {
		HDC hdc;
//		POINT window_org;
		SIZE window_size;
		POINT line_start;
		POINT curr_pos;
		SIZE line_size;
		uint32 line_index; /* of text */
	}render_status;
}MSG_CTX;

KAILIN_API
 int MsgCreate(MSG_CTX *ctx, uint32 width, uint32 height);
KAILIN_API
 int MsgDestroy(MSG_CTX *ctx);
KAILIN_API
 int MsgAppend(MSG_CTX *ctx, const char *text);
KAILIN_API
 int MsgJoin(MSG_CTX *ctx, MSG_CTX *src);
KAILIN_API
 int MsgEmpty(MSG_CTX *ctx);
KAILIN_API
 int MsgRender(MSG_CTX *ctx, INT x, INT y, HDC hOutDC);

#ifdef __cplusplus
};
#endif

#endif
