#ifndef __QUEUE_H__
#define __QUEUE_H__

#include "x/api.h"
#include "x/null.h"
#include "x/type.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef uint32   QUEUE_SIZE;
typedef void    *QUEUE;

KAILIN_API
 int QueueAllocNode(QUEUE *node, QUEUE_SIZE size);
KAILIN_API
 int QueueFreeNode(QUEUE *node);
KAILIN_API
 int QueueFreeAll(QUEUE *head);

KAILIN_API
 int QueueCreateNode(QUEUE *node, QUEUE_SIZE *size);
KAILIN_API
 int QueueReleaseNode(QUEUE *node, QUEUE_SIZE *size);

KAILIN_API
 int QueueIsInclude(QUEUE head, QUEUE node);
KAILIN_API
 int QueueGetNodeSize(QUEUE node, QUEUE_SIZE *size);

KAILIN_API
 int QueueInsertNode(QUEUE pos, QUEUE node);
KAILIN_API
 int QueueRemoveNode(QUEUE *head, QUEUE node);
KAILIN_API
 int QueueInsertNodeToHead(QUEUE *head, QUEUE node);
KAILIN_API
 int QueueRemoveNodeFromHead(QUEUE *head, QUEUE *node);
KAILIN_API
 int QueueInsertNodeToTail(QUEUE *head, QUEUE node);
KAILIN_API
 int QueueRemoveNodeFromTail(QUEUE *head, QUEUE *node);

KAILIN_API
 int QueueGetHeadNode(QUEUE head, QUEUE *node);
KAILIN_API
 int QueueGetTailNode(QUEUE head, QUEUE *node);
KAILIN_API
 int QueueGetPreviousNode(QUEUE head, QUEUE *node);
KAILIN_API
 int QueueGetNextNode(QUEUE head, QUEUE *node);

KAILIN_API
 int QueueGetNodeCount(QUEUE head, int *count);
KAILIN_API
 int QueueGetIndexNode(QUEUE head, QUEUE *node, int index);

KAILIN_API
 int QueueSearchNode(QUEUE head, QUEUE *node, void *addr);

#ifdef __cplusplus
};
#endif

#endif
