#ifndef __STR_H__
#define __STR_H__

#include "x/api.h"
#include "x/type.h"
#include "x/null.h"

#ifdef __cplusplus
extern "C" {
#endif

#define STRINR_MAX_BLOCK_LENGTH       256

KAILIN_API
 int StringGetLength(char *str, uint32 *len);
KAILIN_API
 int StringGetCharacter(char *str, uint32 index, char *cc);
KAILIN_API
 int StringSetCharacter(char **str, uint32 index, char cc);
KAILIN_API
 int StringCopy(char **str, uint32 index, const char *s);
KAILIN_API
 int StringJoin(char **str, const char *s);
KAILIN_API
 int StringJoinCharacter(char **str, char c);
KAILIN_API
 int StringClean(char **str);
KAILIN_API
 int StringDeleteChar(char **str, uint32 index, int len);
KAILIN_API
 int StringBackspace(char **str, uint32 index, int *length);

#ifdef __cplusplus
};
#endif

#endif
