#ifndef __PATH_H__
#define __PATH_H__

#include "x/api.h"

KAILIN_API int path_make(char *buff, int buf_len, const char *dir, const char *uri, const char *name, int offset, int nlimit);
KAILIN_API int path_load(char *buff, int buff_len, const char *base);
KAILIN_API int path_join(char *buff, int buff_len, int limit, const char *file);

KAILIN_API int path_get_dir(const char *s, int offset, int limit); /* [offset, return) */
KAILIN_API int path_get_file_name(const char *s, int offset, int limit); /* [return, limit) */
KAILIN_API int path_get_file_extension(const char *s, int offset, int limit); /* [return, limit) */
KAILIN_API int path_next_node(const char *s, int *offset, int limit); /* [offset, limit) */
KAILIN_API int path_previous_node(const char *s, int offset, int *limit); /* [offset, limit) */

#endif
