#ifndef __PROFILE_H__
#define __PROFILE_H__

#include "x/api.h"

#define MAX_NAME     64
#define MAX_DATA     256

struct s_profile;
struct s_profile_data;
struct s_profile_region;

struct s_profile_data {
	struct s_profile_data *previous, *next;
	char name[MAX_NAME];
	char data[MAX_DATA];
};

struct s_profile {
	struct s_profile_region *region_list;
};

struct s_profile_region {
	struct s_profile_region *previous, *next;
//	struct s_profile profile;
	char name[MAX_NAME];
	struct s_profile_data *data_list;
};

KAILIN_API struct s_profile_region *profile_find_region(struct s_profile *profile, const char *name, int offset, int limit);
KAILIN_API struct s_profile_region *profile_new_region(struct s_profile *profile, const char *name, int offset, int limit);
KAILIN_API struct s_profile_data *profile_find_data(struct s_profile_region *region, const char *name, int offset, int limit);
KAILIN_API struct s_profile_data *profile_new_data(struct s_profile_region *rgn, const char *name, int offset, int limit);
KAILIN_API int profile_get_data(struct s_profile_data *data, char *buf);
KAILIN_API int profile_load(struct s_profile *profile, struct s_profile_region *rgn, const char *filepath);
KAILIN_API int profile_save(struct s_profile *profile, const char *filepath);
KAILIN_API int profile_free(struct s_profile *profile);
KAILIN_API int profile_walk_region(struct s_profile *profile, struct s_profile_region **rgn);

#endif
