#ifndef __STRN_H__
#define __STRN_H__

#include "x/api.h"

#define STRN_NOT_FOUND     (-10000)

#define LENGTH(a) (sizeof(a)/sizeof((a)[0]))
#define SIZE(v) (sizeof(v))

KAILIN_API int strn_set(char *s, int offset, int limit, int c);

KAILIN_API int strn_limit(const char *s, int offset, int limit);

KAILIN_API int strn_chr(const char *s, int offset, int limit, const char *tab);
KAILIN_API int strn_rchr(const char *s, int offset, int limit, const char *tab);
KAILIN_API int strn_lfind(const char *s, int offset, int limit, const char *tab); /* not found return */
KAILIN_API int strn_rfind(const char *s, int offset, int limit, const char *tab); /* not found return */
KAILIN_API int strn_lmove(const char *s, int offset, int limit, const char *tab); /* not found forward */
KAILIN_API int strn_rmove(const char *s, int offset, int limit, const char *tab); /* not found forward */

KAILIN_API int strn_ltrim(const char *s, int offset, int limit);
KAILIN_API int strn_rtrim(const char *s, int offset, int limit);

KAILIN_API int strn_match(const char *s, int offset, int limit, const char *t, int *index);
KAILIN_API int strn_match_list(const char *s, int offset, int limit, const char *list);

KAILIN_API int strn_search(const char *s, int offset, int limit, const char *t);
KAILIN_API int strn_rsearch(const char *s, int offset, int limit, const char *t);
KAILIN_API int strn_skip(const char *s, int offset, int limit, const char *t);
KAILIN_API int strn_rskip(const char *s, int offset, int limit, const char *t);
KAILIN_API int strn_lcmp(const char *s, int offset, int limit, const char *str);
KAILIN_API int strn_rcmp(const char *s, int offset, int limit, const char *str);

KAILIN_API int strn_replace(char *s, int offset, int limit, char c1, char c2);

KAILIN_API int strn_compare(const char *s, int offset, int limit, const char *str);
KAILIN_API int strn_compare_n(const char *s, int offset, int limit, const char *str, int n_off, int n_lmt);

KAILIN_API int strn_save(const char *s, int offset, int limit, char *buf);
KAILIN_API int strn_save_replace(const char *s, int offset, int limit, char *buf, char c1, char c2);
KAILIN_API int strn_load(char *s, int offset, int limit, const char *buf);
KAILIN_API int strn_load_replace(char *s, int offset, int limit, const char *buf, char c1, char c2);
KAILIN_API int strn_load_n(char *s, int offset, int limit, const char *buf, int buf_offset, int buf_limit);
KAILIN_API int strn_copy(char *target, int target_offset, int target_limit, const char *source, int source_offset, int source_limit);

KAILIN_API int strn_dup(const char *s, int offset, int limit, char **buf);

#endif
