#ifndef __VSTR_H__
#define __VSTR_H__

#include "x/api.h"

#define VSTR_BLOCK_SIZE  256

struct s_vstr_block {
	struct s_vstr_block *previous, *next;
	long block_id;
	unsigned char data[VSTR_BLOCK_SIZE];
};

struct s_vstr {
	struct s_vstr_block *list; /* list is ordered, block_id from low to high */
	long vstr_len; /* content character length, not the block length */
};

KAILIN_API int vstr_set_length(struct s_vstr *vs, long length);
KAILIN_API long vstr_length(struct s_vstr *vs);
KAILIN_API int vstr_getchar(struct s_vstr *vs, long offset);
KAILIN_API int vstr_setchar(struct s_vstr *vs, long offset, int c);
KAILIN_API int vstr_sets(struct s_vstr *vs, long offset, const char *s, int len);
KAILIN_API int vstr_gets(struct s_vstr *vs, long offset, char *s, int len);
KAILIN_API int vstr_cmps(struct s_vstr *vs, long offset, const char *s, int len);
KAILIN_API long vstr_lstr(struct s_vstr *vs, long offset, const char *s, int len);
KAILIN_API int vstr_cat(struct s_vstr *vs, const char *s, int len);
KAILIN_API int vstr_dup(struct s_vstr *vs, char **s);
KAILIN_API int vstr_clean(struct s_vstr *vs);
KAILIN_API int vstr_copy(struct s_vstr *vs, char *buff, int buff_len);
KAILIN_API int vstr_walk(struct s_vstr *vs, long offset, struct s_vstr_block **blk);
KAILIN_API long vstr_block_size(struct s_vstr *vs, struct s_vstr_block *blk);
KAILIN_API int vstr_dump(struct s_vstr *vs);

#endif
